import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import be.timvw.framework.security.*;

public class TimeOTPMIDlet extends MIDlet implements CommandListener
{
	private Display display;

	public void startApp() throws  MIDletStateChangeException
	{
		this.display = Display.getDisplay(this);
		this.showSecretTextBox();
	}

	public void pauseApp()
	{
		this.display = null;
	}

	public void destroyApp(boolean unconditional)
	{
		notifyDestroyed();
	}

	public void showSecretTextBox()
	{
		TextBox secretTextBox = new TextBox("Enter Secret:", null, 100, TextField.ANY);
		secretTextBox.addCommand(new Command("Generate", Command.OK, 0));
		secretTextBox.addCommand(new Command("Cancel", Command.CANCEL, 1));
		secretTextBox.setCommandListener(this);
		this.display.setCurrent(secretTextBox);
	}

	public void showGeneratedPassword(String secret)
	{
		Form form = new Form("Generated Password:");
		form.append(new StringItem("", secret));
		form.addCommand(new Command("OK", Command.OK, 0));
		form.setCommandListener(this);
		this.display.setCurrent(form);
	}

	public void commandAction(Command c, Displayable d)
	{
		if (c.getLabel() == "Generate")
		{
			TextBox secretTextBox = (TextBox)d;
			this.generatePassword(secretTextBox.getString());
		}
		else
		{
			destroyApp(true);
		}
	}

	public void generatePassword(String secret)
	{
		TimeOneTimePassword password = new TimeOneTimePassword(secret);
		this.showGeneratedPassword(password.getPassword());
	}
}
